package data;

import java.util.LinkedList;
import java.util.Locale;

import map.SubMap;
import RCWS.Route;

public class SubSol {


	/* INSTANCE FIELDS & CONSTRUCTOR */
	private static long nInstances = 0; // number of instances
	private long id = 0; // solution id
	private double costs = 0.0; // solution costs
	private int[] demand; // total demand
	private LinkedList<Route> routes = new LinkedList<Route>();

	private SubMap sMap = null;
	private float timeLength;
	
	public SubSol(int diffProducts) {
		nInstances++;
		id = nInstances;

		demand = new int[diffProducts];
	}	
	
	public void assignSubMap(SubMap sMap) {
		this.sMap = sMap;
	}
	
	public SubMap getSMap() {
		return this.sMap;
	}
	
	public long getId() {
		return id;
	}

	public double getCosts() {
		return costs;
	}
	
	public void setCosts(double costs) {
		this.costs = costs;
	}

	public int[] getDemand() {
		return demand;
	}

	public int getProductDemand(int product) {
		return demand[product];
	}

	public LinkedList<Route> getRoutes() {
		return routes;
	}

	public void setProductDemand(int product, int demand) {
		this.demand[product] = demand;
	}
	
	public void setTimeLength(float t) {
		this.timeLength = t;
	}
	
	public float getTimeLength() {
		return timeLength;
	}
	
	public void addCosts(Route r) {
		costs += r.getCosts();
	}

	public void removeCosts(Route r) {
		costs -= r.getCosts();
	}

	@Override
	public String toString() {
		StringBuilder builder = new StringBuilder();
		builder.append("\n\t\tSubSol [id=").append(id).append(", costs=")
				.append(String.format(Locale.US, "%.2f",costs))
				.append(", timeLength=")
				.append(String.format(Locale.US, "%.2f",timeLength))
				.append(", \n\t\t\tsMap=")
				.append(sMap).append("\n\t\t]");
		return builder.toString();
	}




}