package models;

public class Customer extends Node{
	
	private final int[] productDemands;

	private final int totalDemand;

	private final SubCustomer[] subCustomers;

	private final boolean[] acceptedVehTypes;

	public Customer(int id, int x, int y, int[] productDemands, boolean[] acceptedVehTypes, String locName) {
		super(id,x,y, locName);
		this.productDemands = productDemands;
		int tmp = 0;
		subCustomers = new SubCustomer[productDemands.length];
		
		for (int i=0; i<productDemands.length; i++) 
			tmp += productDemands[i] ;			
		
		this.totalDemand = tmp;
		
		this.acceptedVehTypes = acceptedVehTypes;
	}
	
	
	public int getDemand(int product) {
		return productDemands[product];
	}
		
	/*** VRP METHODS ***/
	
	@Override
	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = prime * result + getId();
		result = prime * result + getX();
		result = prime * result + getY();
		return result;
	}


	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (getClass() != obj.getClass())
			return false;
		Customer other = (Customer) obj;
		if (getId() != other.getId())
			return false;
		if (getX() != other.getX())
			return false;
		if (getY() != other.getY())
			return false;
		return true;
	}

	public int getTotalDemand() {
		
		return totalDemand;
	}

	public int[] getProductDemands() {
		return productDemands;
	}	
	
	public SubCustomer getSubCustomer(int i) {
		return this.subCustomers[i] ;
	}

	public void setSubCustomer(SubCustomer sc) {
		this.subCustomers[sc.getProduct()] = sc;
	}
	
	public boolean acceptsVehType(VehType vht) {
		return acceptedVehTypes[vht.getId()];
	}


    
}
