package models;

public class Delivery implements Comparable<Delivery> {
	private Customer customer;
	private int product;
	
	public Delivery(Customer customer, int product) {
		this.customer = customer;
		this.product = product;
	}

	public Customer getCustomer() {
		return customer;
	}
	public void setCustomer(Customer customer) {
		this.customer = customer;
	}

	@Override
	public int compareTo(Delivery otherDelivery) {
		
		if (customer == otherDelivery.customer) 
			return ((Integer)product).compareTo((Integer)otherDelivery.product);
		
		return ((Integer)(customer.getId())).compareTo((Integer)(otherDelivery.customer.getId()));
	}

	@Override
	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = prime * result
				+ ((customer == null) ? 0 : customer.hashCode());
		result = prime * result + product;
		return result;
	}

	@Override
	public boolean equals(Object obj) {
		Delivery other = (Delivery)obj;
		if (!customer.equals(other.customer))
			return false;
		if (product != other.product)
			return false;
		return true;
	}

	@Override
	public String toString() {
		StringBuilder builder = new StringBuilder();
		builder.append("[").append(customer.getDemand(product)).append("*(")
				.append(product).append(")->")
				.append(customer).append("]");
		return builder.toString();
	}
	
}
