package models;

import java.util.LinkedList;
import java.util.List;

public class Depot extends Node {
	
	private final int depotId;

	private final List<Vehicle> vehicles;
	private final int[] productsCapacity;
	private final int[] productsReserve;
	
	private final int differentProducts;


	public Depot(int id, int depotId, int x, int y, int[] productsCapacity, int[] productsReserve, String locName) {
		
		super(id,x,y, locName);
		
		this.depotId = depotId;
		this.vehicles = new LinkedList<Vehicle>();
		this.productsCapacity = productsCapacity;
		this.productsReserve = productsReserve;
		this.differentProducts = productsCapacity.length;
	}

	public int getDepotId() {
		return depotId;
	}

	public int getTotalCapacity(int num) {
		return productsCapacity[num];
	}

	public int getDiffProducts() {
		return differentProducts;
	}
	
	public void addVehicle(Vehicle veh) {
		vehicles.add(veh); 
	}

	public List<Vehicle> getVehicles() {
		return vehicles;
	}
	public int[] getProductsCapacity() {
		return productsCapacity;
	}
	
	public int[] getProductsReserve() {
		return productsReserve;
	}

}
