package models;

import RCWS.Edge;
import RCWS.Route;

public class Node {
	protected int id;
	private int x;
	private int y;
	
	private Edge diEdge = null; // edge from depot to node
    private Edge idEdge = null; // edge from node to depot

    private Route inRoute = null; // evolving route containing the node
    private boolean isInterior = false; // interior node in its route
	private String locName; // City name 
    
	public Node(int id, int x, int y, String name) {
		this.id = id;
		this.x = x;
		this.y = y;
		this.locName = name;
	}

	public int getId() {
		// Used to get distances and times from matrices. 
		return id;
	}	
	
	public int getCachingId() {
		// Used to calculate hash for route cache.
		return id;
	}

	public int getX() {
		return x;
	}

	public int getY() {
		return y;
	}
	
	public String getLocName() {
		return this.locName;
	}
	
	public void setDiEdge(Edge e){diEdge = e;}
    public void setIdEdge(Edge e){idEdge = e;}
    
    public Edge getDiEdge(){return diEdge;}
    public Edge getIdEdge(){return idEdge;}
    
    public void setInRoute(Route r){inRoute = r;}
    public void clearInRoute() {inRoute = null;}
    public void setIsInterior(boolean b){isInterior = b;}
   
    public Route getInRoute(){return inRoute;}
    public boolean getIsInterior(){return isInterior;}

	@Override
	public String toString() {
		StringBuilder builder = new StringBuilder();
		builder.append(getClass().getSimpleName().substring(0,1)).append(id);
		return builder.toString();
	}
}
