package models;

import data.Input;

public class SubCustomer extends Node {

	private static int nNode = Input.getNumNodes();
	private Customer customer;
	private int product;
	private int productDemand;

	public SubCustomer(Customer cust, int product) {
		super(nNode++, cust.getX(), cust.getY(), cust.getLocName());

		this.customer = cust;
		this.product = product;
		this.productDemand = cust.getDemand(product);
	}
	
	public int getId() {
		// Used to seek distances and times from matrices
		// Overwrites getId() in Node
		// getCachingId() is not overwritten, which is used to calculate hash for route cache
		return this.getCustomer().getId();
	}

	public Customer getCustomer() {
		return customer;
	}

	public int getProduct() {
		return product;
	}

	public int getDemand() {
		return productDemand;
	}
	
	public boolean acceptsVehType(VehType vht) {
		return this.customer.acceptsVehType(vht);
	}

	@Override
	public String toString() {
		StringBuilder builder = new StringBuilder();
		builder.append("SubCustomer [customer=").append(customer)
				.append(", product=").append(product)
				.append(", productDemand=").append(productDemand).append("]");
		return builder.toString();
	}

	
}
