package models;

import java.util.Arrays;

public class VehType implements Comparable<VehType> {
	private final int id;
	private final int[] capacity;
	private final double fixCost;
	private final double varCost;
	private final int totalCapacity;
	private final int numCompartments;
	private final boolean whCapable;
	
	public VehType(int id, int[] compCapacities, double fixCost, double varCost, boolean whCapable) {
		this.id = id;
		this.capacity = compCapacities;
		int tmpTotalCapacity = 0;
		for(int n: capacity)  tmpTotalCapacity += n;
		totalCapacity= tmpTotalCapacity;
		this.numCompartments = compCapacities.length;
		this.fixCost = fixCost;
		this.varCost = varCost;
		this.whCapable = whCapable;

	}
	
	public int getNumCompartments() {
		return numCompartments;
	}


	public int getCapacity(int compartment) {
		return capacity[compartment];
	}


	public int[] getCapacity() {
		return capacity;
	}


	public double getFixedCost() {
		return fixCost;
	}


	public double getVaribleCost() {
		return varCost;
	}
	
	
	public boolean isWhCapable() {
		return whCapable;
	}

	public int getTotalCapacity() {
		return totalCapacity;
	}
	
	public int getId() {
		return id;
	}	
	
	@Override
	public int compareTo(VehType o) {
		return totalCapacity - o.totalCapacity;
	}

	@Override
	public String toString() {
		StringBuilder builder = new StringBuilder();
		builder.append("VehType [id=").append(id).append(", capacity=")
				.append(Arrays.toString(capacity)).append(", whCapable=")
				.append(whCapable).append("]");
		return builder.toString();
	}
}
